<?php
/**
 * Created by Code Monkeys LLC
 * http://www.codemonkeysllc.com
 * User: Spencer
 * Date: 12/1/2017
 * Time: 10:35 AM
 */

//* ADD MENU ITEM
function hipaa_admin_menu() {
    add_menu_page( 'HIPAA Forms', 'HIPAA Forms', 'access_hipaa_forms', 'hipaa-forms.php', 'hipaa_admin_page', 'dashicons-lock', 6  );
}
add_action( 'admin_menu', 'hipaa_admin_menu' );

//* CREATE ADMIN PAGE
function hipaa_admin_page(){
    // INSTANTIATE CLASS
    $hipaaForms = new cmHipaaForms;

    // GET USER ROLES AND SET APPROVED/NOT APPROVED
    $user = wp_get_current_user();

    $user_id = $user->ID;
    $user_name = $user->user_login;
    $user_display_name = $user->display_name;
    $name_pieces = explode(" ", $user_display_name);
    $user_first_name = $name_pieces[0];
    $user_last_name = $name_pieces[1];
    $user_email = $user->user_email;
    $user_roles = $user->roles;
    $approved = 0;

    /*** SET ADMINISTRATOR ***/
    if(in_array('administrator', $user_roles)) {
        $approved = 1;
        $role = 'administrator';
    }

    /*** SET HIPAA FORMS ROLE ***/
    if(in_array('hipaa_forms', $user_roles)) {
        $approved = 1;
        $role = 'hipaa';
    }

    if($approved == 0) {
        echo 'YOU DO NOT HAVE PERMISSION TO VIEW THIS SECTION!';

        // LOG USER ACCESS
        echo $hipaaForms->accessLog($user_id, $user_name, $user_first_name, $user_last_name, $user_email, $user_roles, $approved);
    } else {
        // GET FORM BUILDER PLUGIN FIELD VALUE
        $formBuilder = esc_attr(get_option('form_builder'));
        $enabledForms = explode(',', esc_attr(get_option('enabled_form_ids')));

        // SET FORM BUILDER SELECT OPTIONS
        $formBuilderOptions = array();

        // CHECK IF CALDERA IS INSTALLED
        $calderaEnabled = 0;
        if(method_exists('Caldera_Forms_Forms','get_forms')) {
            $calderaEnabled = 1;

            if($formBuilder == 'caldera') {
                // SET FORM SELECT FIELD AS CALDERA SELECTED
                $calderaSelected = 'selected="selected"';
            }

            // GET LIST OF CALDERA FORMS
            $formsList = $hipaaForms->getCalderaForms($enabledForms);

            $formBuilderOptions[] = '<option value="caldera"' . $calderaSelected . '>Caldera</option>';
        }

        // CHECK IF GRAVITY ACTIVE
        // todo: add gravity check
        $gravityEnabled = 0;
        if($gravityEnabled == 1 ) {
            $gravityEnabled = 1;

            if($formBuilder == 'gravity') {
                // SET FORM SELECT FIELD AS GRAVITY SELECTED
                $gravitySelected = 'selected="selected"';
            }

            // todo: GET LIST OF GRAVITY FORMS
            $formsList = '';

            $formBuilderOptions[] = '<option value="gravity"' . $gravitySelected . '>Gravity</option>';
        }

        // GET PREFERRED TIME ZONE
        $timeZone = esc_attr(get_option('time_zone'));
        if ($timeZone == 'central') {
            $tzCentralSelected = 'selected="selected"';
        } else {
            if ($timeZone == 'eastern') {
                $tzEasternSelected = 'selected="selected"';
            } else {
                if ($timeZone == 'mountain') {
                    $tzMountainSelected = 'selected="selected"';
                } else {
                    if ($timeZone == 'pacific') {
                        $tzPacificSelected = 'selected="selected"';
                    }
                }
            }
        }

        // GET HIPAA USER ROLE CAPABILITIES
        if(esc_attr(get_option('hipaa_role_read_posts_cap')) == 'on') {
            $hipaaRoleReadPostsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_edit_posts_cap')) == 'on') {
            $hipaaRoleEditPostsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_delete_posts_cap')) == 'on') {
            $hipaaRoleDeletePostsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_install_plugins_cap')) == 'on') {
            $hipaaRoleInstallPluginsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_activate_pluginss_cap')) == 'on') {
            $hipaaRoleActivatePluginsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_edit_plugins_cap')) == 'on') {
            $hipaaRoleEditPluginsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_update_plugins_cap')) == 'on') {
            $hipaaRoleUpdatePluginsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_delete_plugins_cap')) == 'on') {
            $hipaaRoleDeletePluginsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_manage_options_cap')) == 'on') {
            $hipaaRoleManageOptionsChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_manage_categories_cap')) == 'on') {
            $hipaaRoleManageCategoriesChecked = ' checked="checked"';
        }
        if(esc_attr(get_option('hipaa_role_upload_files_cap')) == 'on') {
            $hipaaRoleUploadFilesChecked = ' checked="checked"';
        }
        ?>
        <div class="wrap">
        <h2>HIPAA Forms</h2>
        <div class="cm-hipaa-tabs-wrapper">
            <div class="cm-hipaa-tabs">
                <div class="cm-hipaa-tab active" data="tab-1">
                    Submitted Forms
                </div>
                <?php if($role == 'administrator') { ?>
                    <div class="cm-hipaa-tab" data="tab-2">
                        Selected Forms
                    </div>
                    <div class="cm-hipaa-tab" data="tab-3">
                        Settings
                    </div>
                <?php } ?>
                <div class="cm-hipaa-tab" data="tab-4">
                    Instructions
                </div>
                <div class="cm-hipaa-tab" data="tab-5">
                    FAQ's
                </div>
                <div class="cm-hipaa-tab" data="tab-6">
                    Log
                </div>
                <div class="cm-hipaa-tab" data="tab-7">
                    Support
                </div>
            </div>
            <div class="cm-hipaa-tab-content-wrapper">
                <!-- SUBMITTED FORMS TAB -->
                <div class="cm-hipaa-tab-content" data="tab-1">
                    <h1>Submitted Forms</h1>
                    <div class="cm-submitted-forms-filters-wrapper">
                        <div class="cm-submitted-forms-filters grid_row">
                            <div class="cm-submitted-form-filter col_16">
                                <input type="text" id="cm-submitted-form-filter-first-name" placeholder="First Name"/>
                            </div>
                            <div class="cm-submitted-form-filter col_16">
                                <input type="text" id="cm-submitted-form-filter-last-name" placeholder="Last Name"/>
                            </div>
                            <div class="cm-submitted-form-filter col_16">
                                <input type="text" id="cm-submitted-form-filter-phone" placeholder="Phone #"/>
                            </div>
                            <div class="cm-submitted-form-filter col_16">
                                <input type="text" id="cm-submitted-form-filter-email" placeholder="Email"/>
                            </div>
                            <div class="cm-submitted-form-filter col_16">
                                Results Per Page: <select id="cm-submitted-form-filter-limit">
                                    <option value="5">5</option>
                                    <option value="10" selected="selected">10</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                </select>
                            </div>
                            <div class="cm-submitted-form-filter col_16">
                                <div id="cm-hipaa-submitted-forms-search" class="cm-button">
                                    SEARCH
                                </div>
                            </div>
                            <input type="hidden" id="cm-submitted-form-filter-page" value="0"/>
                            <input type="hidden" id="cm-submitted-form-filter-total" value=""/>
                        </div>
                    </div>
                    <div id="cm-submitted-forms-results">
                    </div>
                </div>
                <?php if($role == 'administrator') { ?>
                    <!-- CURRENT FORM BUILDER FORMS TAB -->
                    <div class="cm-hipaa-tab-content" data="tab-2">
                        <h1>Current Form Plugin: <?php echo $formBuilder; ?></h1>
                        <?php echo $formsList; ?>
                    </div>
                    <!-- PLUGIN SETTINGS TAB -->
                    <div class="cm-hipaa-tab-content" data="tab-3">
                        <h1>HIPAA Forms Settings</h1>
                        <form id="cm_hipaa_forms_options" method="post" action="options.php">
                            <?php
                            settings_fields('cm-hipaa-settings-group');
                            do_settings_sections('cm-hipaa-settings-group');
                            ?>
                            <table class="form-table">
                                <tr valign="top">
                                    <th scope="row">License Key</th>
                                    <td><input type="text" name="license_key" placeholder="License Key"
                                               value="<?php echo esc_attr(get_option('license_key')); ?>"/></td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">Notification Email (receives notices when forms are submitted)</th>
                                    <td><input type="text" name="notification_email" placeholder="Notification Email"
                                               value="<?php echo esc_attr(get_option('notification_email')); ?>"/></td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">Select a Form Builder</th>
                                    <td>
                                        <select name="form_builder">
                                            <?php echo implode('', $formBuilderOptions); ?>
                                        </select>
                                    </td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">Preferred Timezone</th>
                                    <td>
                                        <select name="time_zone">
                                            <option value="central"<?php echo $tzCentralSelected; ?>>Central</option>
                                            <option value="eastern"<?php echo $tzEasternSelected; ?>>Eastern</option>
                                            <option value="mountain"<?php echo $tzMountainSelected; ?>>Mountain</option>
                                            <option value="pacific"<?php echo $tzPacificSelected; ?>>Pacific</option>
                                        </select>
                                    </td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">HIPAA FORMS User Role Capabilities</th>
                                    <td>
                                        <div class="cm-hipaa-forms-role-capabilities">
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_read_posts_cap"<?php echo $hipaaRoleReadPostsChecked; ?> /> Read Posts
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_edit_posts_cap"<?php echo $hipaaRoleEditPostsChecked; ?> /> Edit Posts
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_delete_posts_cap"<?php echo $hipaaRoleDeletePostsChecked; ?> /> Delete Posts
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_install_plugins_cap"<?php echo $hipaaRoleInstallPluginsChecked; ?> /> Install Plugins
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_activate_plugins_cap"<?php echo $hipaaRoleActivatePluginsChecked; ?> /> Activate Plugins
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_edit_plugins_cap"<?php echo $hipaaRoleEditPluginsChecked; ?> /> Edit Plugins
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_update_plugins_cap"<?php echo $hipaaRoleUpdatePluginsChecked; ?> /> Update Plugins
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_delete_plugins_cap"<?php echo $hipaaRoleDeletePluginsChecked; ?> /> Delete Plugins
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_manage_options_cap"<?php echo $hipaaRoleManageOptionsChecked; ?> /> Manage Options
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_manage_categories_cap"<?php echo $hipaaRoleManageCategoriesChecked; ?> /> Manage Categories
                                            </div>
                                            <div class="cm-hipaa-forms-role-cap-input">
                                                <input type="checkbox" name="hipaa_role_upload_files_cap"<?php echo $hipaaRoleUploadFilesChecked; ?> /> Upload Files
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">BAA Agreement</th>
                                    <td id="cm-hipaa-forms-signed-baa"><div class="cm-sign-baa-button">You must sign the BAA Agreement!</div></td>
                                </tr>
                            </table>
                            <input type="hidden" name="enabled_form_ids"
                                   value="<?php echo esc_attr(get_option('enabled_form_ids')); ?>"/>

                            <?php submit_button(); ?>
                        </form>
                    </div>
                <?php } ?>
                <!-- INSTRUCTION TAB -->
                <div class="cm-hipaa-tab-content" data="tab-4">
                    <h1>INSTRUCTIONS</h1>
                    <div class="cm-hipaa-forms-instructions-wrapper">
                        <div class="cm-hipaa-forms-insturctions">
                            <h4 class="cm-hipaa-forms-instructions-title">HOW DOES THIS WORK?</h4>
                            <ol class="cm-hipaa-forms-instructions-content">
                                <li>
                                    First you must purchase a subscription to the HIPAA FORMS Service which is a software as a service "SaaS" API platform.  This service is what handles the storage and PDF generation of the forms and forms CAN NOT be submitted without a subscription.  Once you subscribe to the service a license key will be generated and emailed to you.  Visit <a href="https://www.hipaaforms.online" target="_blank">HIPAA FORMS Service</a> to purchase a subscription.
                                </li>
                                <li>
                                    Next make sure you have Caldera Forms installed.  Caldera is a free form builder plugin that can easily be installed from the "plugins->add" interface and searching for Caldera Forms.  No additional extensions are needed.  We do have plans to include integration with Gravity Forms in the next major release.
                                </li>
                                <li>
                                    Now that you have your license key and Caldera forms installed and activated, go to the "Settings" tab and add your license key, select your preferred compatible form builder plugin (ie. Caldera), enter the email address you wish to receive form submission notices to and set your preferred time zone.
                                </li>
                                <li>
                                    Once the plugin settings are save you need to create a form.  You must have 4 required fields in the form which are needed in order to
                                    filter/search the submitted forms. These fields are:

                                    <ol>
                                        <li>First Name: Must have a text input with the slug "first_name"</li>
                                        <li>Last Name: Must have a text input with the slug "last_name"</li>
                                        <li>Phone: Must have a text or phone input with the slug "phone"</li>
                                        <li>Email: Must have a text or email input with the slug "email"</li>
                                    </ol>
                                </li>
                                <li>
                                    <p>
                                        While you must have both the Phone and Email inputs, only one or the other must
                                        be filled out by the end user in order to validate. Both First Name and Last
                                        Name are always required in order for the form to validate and allow the form to
                                        be sent.
                                    </p>
                                    <p>
                                        If a form has all of the required fields then you will have the option to select
                                        it by checking the box at the left of the form. If the form does NOT have all of
                                        the required fields a warning icon will show next to the form. Clicking on the
                                        warning icon will display what fields are missing.
                                    </p>
                                    <p>
                                        Once you have checked the box next to a form it should be HIPAA
                                        Compliant. To verify the form is now compliant go to where the form is rendered on the page and you should now see an
                                        additional section at the bottom of the form right above the submit button
                                        showing a checkbox to agree to the HIPAA privacy agreement, a badge showing the
                                        form is encrypted and HIPAA compliant and the signature field which a
                                        user can sign by left clicking and dragging their mouse or by simply using their
                                        finger or stylus if on a touch screen.  If you do NOT see these something is not correct and the form will NOT be HIPAA compliant and you should submit a support ticket so our support staff can troubleshoot the issue before attempting to use the form.  It is your responsibility to ensure forms are in a compliant state before allowing patients to submit private protected health information and failure to do so could result in fines.
                                    </p>
                                </li>
                                <li>
                                    <p>
                                        When someone submits the HIPAA Compliant form the default form submit function
                                        is over-ridden and instead will be encrypted and an API call is made to the
                                        HIPAA FORMS API and saved into a HIPAA Compliant database storage solution. The
                                        only fields that are not encrypted are the required first name, last name, phone
                                        # and email in order to allow searching/filtering the forms in the "Submitted
                                        Forms" tab. The form itself (and all fields within it) are encrypted at the time
                                        of submission in order to protect the data in transit as well as at rest within
                                        the HIPAA FORMS Service data solution. If you tried to look at the form at this point you would just see
                                        a long string of nonsense letters, numbers and characters and would not be able
                                        to see any of the actual form data.
                                    </p>
                                    <p>
                                        The only way the form data can be viewed at this point is by logging into the
                                        Wordpress admin panel with valid username and password credentials for an account with the appropriate user role associated to it (administrator or hipaaforms) and opening the "Submitted
                                        Forms" tab within the HIPAA FORMS interface. Here another API request is sent to
                                        the HIPAA FORMS API and the submitted forms data is pulled. Once the data is
                                        returned from the API the associated encryption keys are then used to decrypt
                                        the form data and then display that data on the screen. While you can view this data within this tab the
                                        actual data is never stored anywhere on your server, it simply pulls it from the
                                        HIPAA FORMS Service data solution and displays it. The only way for this data to actually
                                        ever leave our secure system is to generate an encrypted PDF
                                        file with password protection.
                                    </p>
                                </li>
                                <li>
                                    <p>
                                        To generate a PDF version of the form click the "Generate PDF" button next to
                                        the form. This will bring up a modal window (popup) asking you to set a
                                        password. Once a password is provided click generate. The modal window should
                                        update with a link to open the newly created PDF, once you enter the password
                                        the form will load and you will be able to view the form, print it or save it to
                                        your computer.  If you do not keep track of the password you will NOT be able to view the PDF file.
                                    </p>
                                    <p>
                                        The PDF file must be encrypted and password protected to ensure that the form
                                        can never be intercepted and read as it's transferred between the data base and
                                        you. This should also help keep you more compliant internally as the file can
                                        not be read without the correct password once it's saved to your computer. While
                                        ensuring that the PDF files are encrypted and password protected should keep the
                                        data safe and compliant we HIGHLY recommend that any computer you download the
                                        PDFs to have encrypted hard drives to be safe and ensure compliance. Once you print or
                                        download the PDF to your computer Code Monkeys LLC and all associates covered within
                                        the BAA agreement bear no liability for the handling of the data.
                                    </p>
                                </li>
                                <li>
                                    We strongly recommend that you keep up with HIPAA regulation changes and that you
                                    work with a qualified attorney and/or HIPAA Compliance professional to ensure compliance.
                                </li>
                            </ol>
                        </div>
                    </div>
                </div>
                <div class="cm-hipaa-tab-content" data="tab-5">
                    <h1>FAQ's</h1>
                    <div class="cm-hipaa-forms-faqs-wrapper">
                        <div class="cm-hipaa-forms-faqs">
                            <h2>REQUIREMENTS</h2>
                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">YOU MUST HAVE CALDERA FORMS INSTALLED & ACTIVE</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        Currently the HIPAA Forms plugins is only integrated with Caldera Forms.
                                    </p>
                                    <p>
                                        Caldera Forms is a free form builder plugin and can be installed by searching for it in the Wordpress plugin repository (plugins->add new).
                                    </p>
                                    <p>
                                        We plan to add Gravity Forms support very soon in the next major release.
                                    </p>
                                </div>
                            </div>

                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">YOU MUST HAVE SSL ENABLED</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        The HIPAA FORMS plugin checks to ensure SSL (https) is enabled and being
                                        used.
                                    </p>
                                    <p>
                                        Any forms set as HIPAA Compliant will be deactivated if the url does not
                                        start with https://.
                                    </p>
                                    <p>
                                        If you're unable to setup SSL with your current host or if your current
                                        host's cost is too expensive consider a managed hosting (and optional
                                        Wordpress maintenance package) from Code Monkeys. We automatically issue
                                        free SSL certificates to all of our hosting customers. <a
                                                href="https://www.codemonkeysllc.com/hosting" target="_blank">CLICK
                                            HERE FOR DETAILS</a>
                                    </p>
                                </div>
                            </div>

                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">YOU MUST HAVE A VALID LICENSE KEY</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        You can purchase a license key from <a href="https://www.hipaaforms.online" target="_blank">hipaaforms.online</a> as a monthly or annual subscription basis.
                                    </p>
                                    <p>
                                        While this plugin is free to install and use, the HIPAA FORMS plugin is integrated with a paid monthly subscription
                                        service and you must have an active account with a valid license key to use
                                        this service. If your license key expires your forms designated as HIPAA
                                        Compliant will become deactivated until you renew your license key.
                                    </p>
                                    <p>
                                        Why do we have to charge for this service?<br/>
                                        The encrypted form data is submitted to our HIPAA Forms API and stored on a
                                        HIPAA COMPLIANT data storage solution in order to make the form submissions
                                        compliant with HIPAA regulations which we incur a cost for both the
                                        bandwidth and the data storage usage. In addition to the bandwidth and
                                        storage costs involved we must also maintain the system and keep up with any
                                        changes that may occur in the HIPAA REGULATIONS.
                                    </p>
                                    <p>
                                        Finally, given the nature of working with private health information and securing this information according to the HIPAA guidlines we incur a certain amount of risk and liability and must in turn carry additional liability insurance coverage and do everything within our power to ensure that this data remains secure in all stages of the information's life cycle as well as keep a continuous log of access to this data.
                                    </p>
                                </div>
                            </div>

                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">YOU CAN ONLY SUBMIT & VIEW FORMS FROM YOUR ASSOCIATED DOMAIN</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        Forms can only be submitted and viewed from the domain you added to your HIPAA FORMS Service subscription account at the time of checkout.
                                    </p>
                                    <p>
                                        When a request is made to the HIPAA FORMS Service API it does a check against your license key, domain and if a BAA agreement has been signed.  If any of those things are not valid the API request is denied and an error will be returned specifying what the issue is.
                                    </p>
                                    <p>
                                        Only one license key and domain is allowed per subscription meaning you can NOT use the same license or domain on more than one website.
                                    </p>
                                    <p>
                                        This is done as an additional security measure to ensure that even if a license key is stolen form data would not be accessible.
                                    </p>
                                </div>
                            </div>

                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">YOU MUST SIGN THE BAA AGREEMENT</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        A Business Associate Agreement (BAA) typically is required for companies that are subject to the Health Insurance Portability and Accountability Act (HIPAA) to ensure that protected health information (PHI) is appropriately safeguarded. Failure to manage data privacy risks with non-business associate vendors may lead to both violations of HIPAA and state privacy laws.
                                    </p>
                                    <p>
                                        The BAA agreement is in place for your protection and forms can not be submitted or viewed until it is in place.
                                    </p>
                                    <p>
                                        We also recommend that you have a BAA in place with your web designer if they work on the site as a 3rd party contractor.
                                    </p>
                                </div>
                            </div>

                            <h2>COMMON ISSUES</h2>
                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">Email Notices Going to Spam</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        Default Wordpress emails get sent through your host's domain which often
                                        times will be flagged as spam.
                                    </p>
                                    <p>
                                        We highly recommend installing an email SMTP plugin for Wordpress and using
                                        the SMTP settings for a legit email address. This will allow Wordpress to
                                        send emails from the SMTP server instead of from your host.
                                    </p>
                                </div>
                            </div>

                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">Forms Are Disabled / No HIPAA Compliant Badge
                                    Appears</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        If you do NOT see the additional section at the bottom of the form with the
                                        HIPAA compliant badge then there is an issue somewhere and the form will NOT
                                        be disabled as it will not be HIPAA compliant. A common reason this might
                                        happen is if you do NOT have SSL (https://) enabled or if the user is
                                        viewing the http:// version of the page. We strongly recommend that you
                                        setup a redirect in your .htaccess file or by using a plugin to ensure all
                                        pages are served the https:// version of the page. If this is the case the
                                        form will be disabled and you should see a warning notice at the bottom of
                                        the form instead of the badge.
                                    </p>
                                    <p>
                                        Another common reason you might not see this section is if your license key
                                        has expired. If this is the case you should see a warning notice at the
                                        bottom of the form and the form will be disabled. Reactivating your license
                                        key will solve the issue and your form will be enabled again.
                                    </p>
                                    <p>
                                        A less common reason for this would be if another plugin is causing a
                                        Javascript/jQuery error or conflict.
                                    </p>
                                </div>
                            </div>

                            <h2>COMMON QUESTIONS</h2>
                            <div class="cm-hipaa-forms-faqs-item">
                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">What is a BAA?</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        A Business Associate Agreement (BAA) typically is required for companies that are subject to the Health Insurance Portability and Accountability Act (HIPAA) to ensure that protected health information (PHI) is appropriately safeguarded. Failure to manage data privacy risks with non-business associate vendors may lead to both violations of HIPAA and state privacy laws.
                                    </p>
                                    <p>
                                        You will be unable to use the HIPAA FORMS Service until you have signed the BAA with Code Monkeys LLC (the developers of the service) and will receive a notice to do so within the "submitted forms" tab as well as in the settings tab until it has been signed.
                                    </p>
                                    <p>
                                        We HIGHLY recommend that you have a BAA in place with your web designer as well if you use a 3rd party contractor for web design service.
                                    </p>
                                </div>

                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">Can We Modify/Extend This Plugin?</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        WE STRONGLY RECOMMEND NOT MODIFYING THE FUNCTIONALITY OF THIS PLUGIN!
                                    </p>
                                    <p>
                                        This plugin is released under the GPL license and is open source allowing you to modify the plugin however we strongly recommend against attempting to modify the core functionality of the plugin.  The plugin simply acts as an interface to the API service where most of the "under the hood" functionality lives however some functionality such as encryption prior to sending the form data to the API happens within the plugin.  Breaking or disabling this encryption process could result in non-encrypted private protected sensitive health information being submitted which would be a HIPAA violation and may lead to both violations of HIPAA and state privacy laws.
                                    </p>
                                    <p>
                                        While we recommend not modifying the core functionality of the plugin changing the CSS/Styles is totally fine and recommended.
                                    </p>
                                </div>

                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">Can Images/Files be Attached to Forms?</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        We do not allow attachments to be submitted as this would be very difficult to properly secure under HIPAA guidelines while still making accessible to you and your approved staff.
                                    </p>
                                    <p>
                                        In addition to the difficulty in securing the attachments it opens up a potential vulnerability as malicious code can often be disguised as an image or file attachment which could put everyone's protected data at risk.
                                    </p>
                                    <p>
                                        Finally, even if we were able to confidently safegaurd against the first two concerns, the cost of storing large file attachments would drive the over-all price of the service significantly higher making it unaffordable for many smaller sized businesses.
                                    </p>
                                </div>

                                <h4 class="cm-toggle cm-hipaa-forms-faqs-title">Why is it Logged Every Time Someone Goes to the HIPAA FORMS Admin Dashboard?</h4>
                                <div class="cm-toggle-content cm-hipaa-forms-faqs-content">
                                    <p>
                                        A part of the HIPAA guidelines is that access logs are kept each time someone has access to protected health information.
                                    </p>
                                    <p>
                                        This allows you to look back through the logs to see who accessed the information during a specific time period in case you suspect a violation of policy or data breach.
                                    </p>
                                    <p>
                                        This log data is saved in the HIPAA FORMS Service database to ensure the integrity of the data and may be shared with investigators if requested by authorities if a potential data breach or violation is suspected.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="cm-hipaa-tab-content" data="tab-6">
                    <h1>Access Logs</h1>
                    <div class="cm-hipaa-forms-logs-filters-wrapper">
                        <div class="cm-hipaa-forms-logs-filters grid_row">
                            <div class="cm-hipaa-forms-logs-filter col_16">
                                <input type="text" id="cm-hipaa-forms-logs-filter-start-date" placeholder="Start Date"/>
                            </div>
                            <div class="cm-hipaa-forms-logs-filter col_16">
                                <input type="text" id="cm-hipaa-forms-logs-filter-end-date" placeholder="End Date"/>
                            </div>
                            <div class="cm-hipaa-forms-logs-filter col_16">
                                Results Per Page: <select id="cm-hipaa-forms-logs-filter-limit">
                                    <option value="5">5</option>
                                    <option value="10" selected="selected">10</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                </select>
                            </div>
                            <div class="cm-hipaa-forms-logs-filter col_16">
                                <div id="cm-hipaa-forms-logs-search" class="cm-button">
                                    SEARCH
                                </div>
                            </div>
                            <input type="hidden" id="cm-hipaa-forms-logs-filter-page" value="0"/>
                            <input type="hidden" id="cm-hipaa-forms-logs-filter-total" value=""/>
                        </div>
                    </div>
                    <div id="cm-hipaa-forms-logs-results">
                    </div>
                </div>
                <div class="cm-hipaa-tab-content" data="tab-7">
                    <h1>Support</h1>
                    <div class="cm-hipaa-forms-tickets-wrapper grid_row">
                        <div class="col_33">
                            <h2>Submit a Ticket</h2>
                            <div class="cm-hipaa-forms-submit-tickets">
                                <div class="cm-hipaa-forms-submit-ticket-input">
                                    <select id="cm-hipaa-forms-submit-ticket-priority">
                                        <option value="">PRIORITY</option>
                                        <option value="low">Low</option>
                                        <option value="medium">Medium</option>
                                        <option value="high">High</option>
                                    </select>
                                </div>
                                <div class="cm-hipaa-forms-submit-ticket-input">
                                    <input type="text" id="cm-hipaa-forms-submit-ticket-subject" placeholder="Subject..." />
                                </div>
                                <div class="cm-hipaa-forms-submit-ticket-input">
                                    <textarea id="cm-hipaa-forms-submit-ticket-message" placeholder="Message..."></textarea>
                                </div>
                                <div id="cm-hipaa-forms-submit-ticket" class="cm-button">
                                    SUBMIT
                                </div>
                                <div id="cm-hipaa-forms-submit-ticket-notice"></div>
                            </div>
                        </div>
                        <div class="col_33">
                            <h2>Open Tickets</h2>
                            <div id="cm-hipaa-forms-open-tickets"></div>
                        </div>
                        <div class="col_33">
                            <h2>Closed Tickets</h2>
                            <div id="cm-hipaa-forms-closed-tickets"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <?php

        // LOG USER ACCESS
        $hipaaForms->accessLog($user_id, $user_name, $user_first_name, $user_last_name, $user_email, $user_roles, $approved);
    }
}