<?php
/**
 * Created by Code Monkeys LLC
 * http://www.codemonkeysllc.com
 * User: Spencer
 * Date: 11/29/2017
 * Time: 12:36 PM
 */

//* ENQUEUE ADMIN SCRIPTS AND STYLES
function cm_hipaa_enqueue_admin_scripts() {
    // ENQUEUE CSS
    wp_enqueue_style( 'cmHipaaAdminStyle', plugin_dir_url(__FILE__) . '/css/admin-style.css' );

    // ENQUEUE SCRIPT
    wp_enqueue_script( 'jquery-form' );
    wp_enqueue_script( 'cmHipaaAdminScript', plugin_dir_url(__FILE__) . '/js/admin-script.js', array('jquery'), '2.0', true );
    wp_enqueue_script('cm-hipaa-signature', plugin_dir_url(__FILE__) . 'js/jSignature/jSignature.min.noconflict.js', array('jquery'), '2.0', true);
    wp_enqueue_script('font-awesome', '//use.fontawesome.com/releases/v5.0.1/js/all.js');
    wp_enqueue_script('font-awesome', '//use.fontawesome.com/releases/v5.0.1/js/v4-shims.js');

    // PASS PHP DATA TO SCRIPT FILE
    global $post;
    wp_localize_script('cmHipaaAdminScript', 'hipaaScript', array(
        'pluginUrl' => plugin_dir_url(__FILE__),
        'siteUrl' =>  get_site_url(),
        'nonce' => wp_create_nonce( "cm-hipaa-forms-nonce" )
    ));

    // LOCALIZE CUSTOM JS FILE TO USE WITH AJAX
    wp_localize_script( 'cmHipaaAdminScript', 'ajax', array(
        'ajax_url' => admin_url( 'admin-ajax.php' )
    ));

}
add_action( 'admin_enqueue_scripts', 'cm_hipaa_enqueue_admin_scripts' );

//* ENQUEUE FRONT END AJAX JAVASCRIPT
function enqueue_cm_hipaa_scripts() {
    // ENQUEUE CSS
    wp_enqueue_style( 'cmHipaaAdminStyle', plugin_dir_url(__FILE__) . '/css/style.css' );

    // ENQUEUE CUSTOM JS
    wp_enqueue_script('cm-hipaa-script', plugin_dir_url(__FILE__) . 'js/script.js', array('jquery'), '2.0', true);
    wp_enqueue_script('cm-hipaa-signature', plugin_dir_url(__FILE__) . 'js/jSignature/jSignature.min.noconflict.js', array('jquery'), '2.0', true);

    // CHECK IF HOMEPAGE
    if (is_front_page()) {
        $frontpage = 1;
    } else {
        $frontpage = 0;
    }

    // CHECK IF USING SSL
    if (is_ssl()) {
        $ssl = 1;
    } else {
        $ssl = 0;
    }

    // GET ENABLED FORMS
    $enabledForms = json_encode(explode(',', esc_attr(get_option('enabled_form_ids'))));

    // PASS PHP DATA TO SCRIPT FILE (use example: cmHipaaScript.siteUrl)
    wp_localize_script('cm-hipaa-script', 'cmHipaaScript', array(
        'pluginUrl' => plugin_dir_url(__FILE__),
        'siteUrl' => get_site_url(),
        'frontPage' => $frontpage,
        'enabledForms' => $enabledForms,
        'ssl' => $ssl,
        'nonce' => wp_create_nonce( "cm-hipaa-forms-nonce" )
    ));

    // LOCALIZE CUSTOM JS FILE TO USE WITH AJAX
    wp_localize_script('cm-hipaa-script', 'ajax', array(
        'ajax_url' => admin_url('admin-ajax.php')
    ));

}
add_action('wp_enqueue_scripts', 'enqueue_cm_hipaa_scripts');