<?php
/**
 * Created by Code Monkeys LLC
 * http://www.codemonkeysllc.com
 * User: Spencer
 * Date: 11/28/2017
 * Time: 5:57 PM
 */

/*** CREATE ADMIN SETTING MENU ITEM ***/
function cm_hipaa_menu() {
    add_options_page('HIPAA Forms Options', 'HIPAA Forms Options', 'administrator', __FILE__, 'cm_hipaa_settings_page', '');
}
add_action( 'admin_menu', 'cm_hipaa_menu' );

/*** REGISTER SETTINGS OPTIONS ***/
function register_cm_hipaa_settings() {
    register_setting( 'cm-hipaa-settings-group', 'notification_email' );
    register_setting( 'cm-hipaa-settings-group', 'license_key' );
    register_setting( 'cm-hipaa-settings-group', 'form_builder' );
    register_setting( 'cm-hipaa-settings-group', 'time_zone' );
    register_setting( 'cm-hipaa-settings-group', 'enabled_form_ids' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_read_posts_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_edit_posts_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_delete_posts_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_install_plugins_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_activate_plugins_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_edit_plugins_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_update_plugins_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_delete_plugins_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_manage_options_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_manage_categories_cap' );
    register_setting( 'cm-hipaa-settings-group', 'hipaa_role_upload_files_cap' );
}
add_action( 'admin_init', 'register_cm_hipaa_settings' );

/*** CREATE SETTINGS PAGE ***/
function cm_hipaa_settings_page() {
    // GET FOR BULDER PLUGIN FIELD VALUE
    $formBuilder = esc_attr( get_option('form_builder') );
    if($formBuilder == 'caldera') {
        $calderaSelected = 'selected="selected"';
    } else if($formBuilder == 'gravity') {
        $gravitySelected = 'selected="selected"';
    }

    // GET PREFERRED TIME ZONE
    $timeZone = esc_attr(get_option('time_zone'));
    if($timeZone == 'central') {
        $tzCentralSelected = 'selected="selected"';
    } else if($timeZone == 'eastern') {
        $tzEasternSelected = 'selected="selected"';
    } else if($timeZone == 'mountain') {
        $tzMountainSelected = 'selected="selected"';
    } else if($timeZone == 'pacific') {
        $tzPacificSelected = 'selected="selected"';
    }

    // GET HIPAA USER ROLE CAPABILITIES
    if(esc_attr(get_option('hipaa_role_read_posts_cap')) == 'on') {
        $hipaaRoleReadPostsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_edit_posts_cap')) == 'on') {
        $hipaaRoleEditPostsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_delete_posts_cap')) == 'on') {
        $hipaaRoleDeletePostsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_install_plugins_cap')) == 'on') {
        $hipaaRoleInstallPluginsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_activate_pluginss_cap')) == 'on') {
        $hipaaRoleActivatePluginsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_edit_plugins_cap')) == 'on') {
        $hipaaRoleEditPluginsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_update_plugins_cap')) == 'on') {
        $hipaaRoleUpdatePluginsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_delete_plugins_cap')) == 'on') {
        $hipaaRoleDeletePluginsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_manage_options_cap')) == 'on') {
        $hipaaRoleManageOptionsChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_manage_categories_cap')) == 'on') {
        $hipaaRoleManageCategoriesChecked = ' checked="checked"';
    }
    if(esc_attr(get_option('hipaa_role_upload_files_cap')) == 'on') {
        $hipaaRoleUploadFilesChecked = ' checked="checked"';
    }
    ?>
    <div class="wrap">
        <h1>HIPAA Forms Settings</h1>

        <form method="post" action="options.php">
            <?php
            settings_fields( 'cm-hipaa-settings-group' );
            do_settings_sections( 'cm-hipaa-settings-group' );
            ?>
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">License Key</th>
                    <td><input type="text" name="license_key" placeholder="License Key" value="<?php echo esc_attr( get_option('license_key') ); ?>" /></td>
                </tr>
                <tr valign="top">
                    <th scope="row">Notification Email (receives notices when forms are submitted)</th>
                    <td><input type="text" name="notification_email" placeholder="Notification Email" value="<?php echo esc_attr( get_option('notification_email') ); ?>" /></td>
                </tr>
                <tr valign="top">
                    <th scope="row">Select a Form Builder</th>
                    <td>
                        <select name="form_builder">
                            <option value="caldera"<?php echo $calderaSelected; ?>>Caldera</option>
                            <option value="gravity"<?php echo $gravitySelected; ?>>Gravity</option>
                        </select>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">Preferred Timezone</th>
                    <td>
                        <select name="time_zone">
                            <option value="central"<?php echo $tzCentralSelected; ?>>Central</option>
                            <option value="eastern"<?php echo $tzEasternSelected; ?>>Eastern</option>
                            <option value="mountain"<?php echo $tzMountainSelected; ?>>Mountain</option>
                            <option value="pacific"<?php echo $tzPacificSelected; ?>>Pacific</option>
                        </select>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">HIPAA FORMS User Role Capabilities</th>
                    <td>
                        <div class="cm-hipaa-forms-role-capabilities">
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_read_posts_cap"<?php echo $hipaaRoleReadPostsChecked; ?> /> Read Posts
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_edit_posts_cap"<?php echo $hipaaRoleEditPostsChecked; ?> /> Edit Posts
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_delete_posts_cap"<?php echo $hipaaRoleDeletePostsChecked; ?> /> Delete Posts
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_install_plugins_cap"<?php echo $hipaaRoleInstallPluginsChecked; ?> /> Install Plugins
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_activate_plugins_cap"<?php echo $hipaaRoleActivatePluginsChecked; ?> /> Activate Plugins
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_edit_plugins_cap"<?php echo $hipaaRoleEditPluginsChecked; ?> /> Edit Plugins
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_update_plugins_cap"<?php echo $hipaaRoleUpdatePluginsChecked; ?> /> Update Plugins
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_delete_plugins_cap"<?php echo $hipaaRoleDeletePluginsChecked; ?> /> Delete Plugins
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_manage_options_cap"<?php echo $hipaaRoleManageOptionsChecked; ?> /> Manage Options
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_manage_categories_cap"<?php echo $hipaaRoleManageCategoriesChecked; ?> /> Manage Categories
                            </div>
                            <div class="cm-hipaa-forms-role-cap-input">
                                <input type="checkbox" name="hipaa_role_upload_files_cap"<?php echo $hipaaRoleUploadFilesChecked; ?> /> Upload Files
                            </div>
                        </div>
                    </td>
                </tr>
            </table>
            <input type="hidden" name="enabled_form_ids" value="<?php echo esc_attr( get_option('enabled_form_ids') ); ?>" />

            <?php submit_button(); ?>
        </form>
    </div>
    <?php
}