
jQuery(document).ready(function() {
    /*** CHECK IF SSL ENABLED ***/
    var protocol = document.location.protocol;

    if(protocol !== 'https:') {
        jQuery('.cm-hipaa-tabs-wrapper').prepend('<div class="cm-hipaa-forms-ssl-notice">SSL MUST BE ENABLED!</div>');
    }

    /*** GET BAA AGREEMENT PDF URL ON PAGE LOAD ***/
    cmGetBaaPdf();

    /*** GET FORMS ON PAGE LOAD ***/
    cmGetForms();

    /*** GET OPEN SUPPORT TICKETS ***/
    cmGetTickets('open', jQuery('#cm-hipaa-forms-open-tickets'));

    /*** GET CLOSED SUPPORT TICKETS ***/
    cmGetTickets('closed', jQuery('#cm-hipaa-forms-closed-tickets'));

    /*** TABS ***/
    jQuery('.cm-hipaa-tab').click(function() {
        var data = jQuery(this).attr('data');
        var content = jQuery('.cm-hipaa-tab-content[data="' + data + '"]');

        if(!content.is(':visible')) {
            jQuery('.cm-hipaa-tab').removeClass('active');
            jQuery(this).addClass('active');

            jQuery('.cm-hipaa-tab-content').fadeOut().promise().done(function() {
                content.fadeIn();
            });
        }
    });

    /*** GENERIC TOGGLES ***/
    jQuery(document).on('click', '.cm-toggle', function() {
        jQuery(this).next().slideToggle();
    });

    /*** TOGGLE FIELDS ***/
    jQuery(document).on('click', '.cm-hipaa-toggle-fields', function() {
        var content = jQuery(this).parent().parent().find('.cm-hipaa-select-form-item-fields');

        if(content.is(':visible')) {
            jQuery(this).html('<i class="far fa-caret-square-down"></i>');
        } else {
            console.log('not visible');
            jQuery(this).html('<i class="far fa-caret-square-up"></i>');
        }

        content.slideToggle();
    });

    /*** TOGGLE ERRORS ***/
    jQuery(document).on('click', '.cm-hipaa-toggle-errors', function() {
        var content = jQuery(this).parent().parent().find('.cm-hipaa-select-form-item-errors');

        content.slideToggle();
    });

    /*** GET/FILTER SUBMITTED FORMS ***/
    jQuery('#cm-hipaa-submitted-forms-search').click(function() {
        var firstName = jQuery('#cm-submitted-form-filter-first-name').val();
        var lastName = jQuery('#cm-submitted-form-filter-last-name').val();
        var phone = jQuery('#cm-submitted-form-filter-phone').val();
        var email = jQuery('#cm-submitted-form-filter-email').val();
        var limit = jQuery('#cm-submitted-form-filter-limit').val();
        var page = jQuery('#cm-submitted-form-filter-page').val();
        var resultsEle = jQuery('#cm-submitted-forms-results');

        // GET FORMS
        cmGetForms(firstName, lastName, phone, email, limit, 0, resultsEle);
    });

    /*** SUBMITTED FORMS PAGINATION PREVIOUS ***/
    jQuery(document).on('click', '#cm-hipaa-submitted-forms-prev .cm-pagination-button', function() {
        var firstName = jQuery('#cm-submitted-form-filter-first-name').val();
        var lastName = jQuery('#cm-submitted-form-filter-last-name').val();
        var phone = jQuery('#cm-submitted-form-filter-phone').val();
        var email = jQuery('#cm-submitted-form-filter-email').val();
        var limit = jQuery('#cm-submitted-form-filter-limit').val();
        var page = jQuery('#cm-submitted-form-filter-page').val();
        var resultsEle = jQuery('#cm-submitted-forms-results');
        var newPage = parseInt(page, 10)-1;

        cmGetForms(firstName, lastName, phone, email, limit, newPage, resultsEle);
    });

    /*** SUBMITTED FORMS PAGINATION NEXT ***/
    jQuery(document).on('click', '#cm-hipaa-submitted-forms-next .cm-pagination-button', function() {
        var firstName = jQuery('#cm-submitted-form-filter-first-name').val();
        var lastName = jQuery('#cm-submitted-form-filter-last-name').val();
        var phone = jQuery('#cm-submitted-form-filter-phone').val();
        var email = jQuery('#cm-submitted-form-filter-email').val();
        var limit = jQuery('#cm-submitted-form-filter-limit').val();
        var page = jQuery('#cm-submitted-form-filter-page').val();
        var resultsEle = jQuery('#cm-submitted-forms-results');
        var newPage = parseInt(page, 10)+1;

        cmGetForms(firstName, lastName, phone, email, limit, newPage, resultsEle);
    });

    /*** SELECT / DESELECT FORM ***/
    jQuery('.cm-hipaa-form-select').click(function() {
        var item = jQuery(this).parent().parent();
        var formId = item.attr('id');
        var enabledIdsInput = jQuery('form#cm_hipaa_forms_options input[name="enabled_form_ids"]');
        var enabledIds = enabledIdsInput.val();
        var selected;
        var newEnabledIds;

        if(item.hasClass('selected') && !item.hasClass('errors')) {
            item.removeClass('selected');
            jQuery(this).html('<i class="far fa-square"></i>');

            // REMOVE FORM ID FROM ENABLED FORMS INPUT STRING
            newEnabledIds = enabledIds.replace(formId + ',', '');

            // UPDATE ENABLED FORMS INPUT
            enabledIdsInput.val(newEnabledIds);

            selected = false;
        } else if(!item.hasClass('selected') && !item.hasClass('errors')) {
            item.addClass('selected');
            jQuery(this).html('<i class="far fa-check-square"></i>');

            // APPEND FORM ID TO ENABLED FORMS INPUT STRING
            newEnabledIds = enabledIds + formId + ',';

            // UPDATE ENABLED FORMS INPUT
            enabledIdsInput.val(newEnabledIds);

            selected = true;
        }


        // SAVE FORM
        jQuery('form#cm_hipaa_forms_options').ajaxSubmit({
            success: function(){
                console.log('saved');
            },
            error: function (errorThrown) {
                console.log(errorThrown);
            }
        });
    });

    /*** OPEN GENERATE PDF MODAL ***/
    jQuery(document).on('click', '.cm-hipaa-generate-pdf-modal-button', function() {
        var formId = jQuery(this).attr('data');

        // CREATE THE MODAL
        jQuery('body').append('<div class="cm-hipaa-forms-modal"><div class="cm-hipaa-forms-modal-inner"><div class="cm-hipaa-forms-modal-inner-top"><div class="cm-hipaa-forms-modal-close"><i class="fa fa-times-circle" aria-hidden="true"></i></div></div><div class="cm-hipaa-forms-modal-inner-body"><div class="cm-hipaa-forms-modal-text">Specify a password that will be used to open the encrypted PDF:</div><div class="cm-hipaa-forms-modal-inputs"><input id="cm-hipaa-forms-pdf-password-input" type="text" placeholder="PASSWORD (min. 6 characters)" value="" /></div><div class="cm-hipaa-forms-generate-pdf cm-button" data="' + formId + '">GENERATE PDF</div></div></div></div>');

        // FADE IN MODAL
        jQuery('.cm-hipaa-forms-modal').fadeIn();
    });

    /*** CLOSE MODAL ***/
    jQuery(document).on('click', '.cm-hipaa-forms-modal-close', function() {
        var modal = jQuery(this).parent().parent().parent();
        var pdfUrl = jQuery(this).attr('data-url');
        var nonce = hipaaScript.nonce;

        if(pdfUrl) {
            // DELETE PDF
            jQuery.ajax({
                method: 'POST',
                url: ajax.ajax_url,
                data: {
                    'action': 'cm_hipaa_delete_pdf',
                    'url': pdfUrl,
                    'nonce': nonce
                },
                success: function (data) {
                    console.log(data);
                },
                error: function (errorThrown) {
                    console.log(errorThrown);
                }
            });
        }

        // REMOVE MODAL WINDOW
        modal.fadeOut().promise().done(function() {
            modal.remove();
        });
    });

    /*** ACTIVATE/DEACTIVATE GENERATE PDF BUTTON BASED ON PASSWORD FIELD ***/
    jQuery(document).on('keyup', '#cm-hipaa-forms-pdf-password-input', function(e) {
        if(jQuery(this).val().length >= 6 || event.keyCode == 13) {
            jQuery('.cm-hipaa-forms-generate-pdf').addClass('active').promise().done(function() {
                // FIRE GENERATE PDF BUTTON ON ENTER WHILE IN PASSWORD INPUT
                if(e.keyCode == 13) {
                    jQuery('.deal_search_submit.active').trigger('click');
                }
            });
        } else {
            jQuery('.cm-hipaa-forms-generate-pdf').removeClass('active');
        }
    });

    /*** GENERATE PDF ***/
    jQuery(document).on('click', '.cm-hipaa-forms-generate-pdf.active', function() {
        var formId = jQuery(this).attr('data');
        var pdfPassword = jQuery('#cm-hipaa-forms-pdf-password-input').val();
        var nonce = hipaaScript.nonce;

        // CREATE PDF
        jQuery.ajax({
            method: 'POST',
            url: ajax.ajax_url,
            data: {
                'action': 'cm_hipaa_generate_pdf',
                'form_id': formId,
                'pdf_password': pdfPassword,
                'nonce': nonce
            },
            success: function (data) {
                var pdfData = JSON.parse(data);

                // UPDATE THE MODAL WINDOW
                jQuery('.cm-hipaa-forms-modal-inner-body').html(pdfData.modal_message);

                // ADD PDF URL TO CLOSE BUTTON
                jQuery('.cm-hipaa-forms-modal-close').attr('data-url', pdfData.pdf_url);
            },
            error: function (errorThrown) {
                console.log(errorThrown);
                jQuery('.cm-hipaa-forms-modal-inner-body').html(errorThrown);
            }
        });
    });

    /*** TOGGLE SUBMITTED FORM FIELDS ***/
    jQuery(document).on('click', '.cm-hipaa-submitted-form-toggle-fields', function() {
        var fields = jQuery(this).parent().parent().parent().next().find('.cm-hipaa-submitted-form-fields');

        // UPDATE ICON
        if(fields.is(':visible')) {
            jQuery(this).html('<i class="far fa-caret-square-down"></i>');
        } else {
            jQuery(this).html('<i class="far fa-caret-square-up"></i>');
        }

        // TOGGLE FIELDS
        fields.slideToggle();
    });

    /*** DELETE FORM ***/
    jQuery(document).on('click', '.cm-hipaa-submitted-form-delete', function() {
        var formRow = jQuery(this).parent().parent().parent();
        var formId = formRow.attr('data-id');
        var nonce = hipaaScript.nonce;

        // DELETE FORM
        jQuery.ajax({
            method: 'POST',
            url: ajax.ajax_url,
            data: {
                'action': 'cm_hipaa_delete_form',
                'form_id': formId,
                'nonce': nonce
            },
            success: function (data) {
                console.log(data);
                var returnData = JSON.parse(data);

                if(returnData.success === 'success') {
                    formRow.remove();
                    formRow.next().remove();
                }
            },
            error: function (errorThrown) {
                console.log(errorThrown);
            }
        });
    });

    /*** GET/FILTER ACCESS LOGS ***/
    jQuery('#cm-hipaa-forms-logs-search').click(function() {
        var startDate = jQuery('#cm-hipaa-forms-logs-filter-start-date').val();
        var endDate = jQuery('#cm-submitted-form-filter-end-date').val();
        var limit = jQuery('#cm-hipaa-forms-logs-filter-limit').val();
        var page = jQuery('#cm-hipaa-forms-logs-filter-page').val();
        var resultsEle = jQuery('#cm-hipaa-forms-logs-results');

        // GET FORMS
        cmGetLogs(startDate, endDate, limit, 0, resultsEle);
    });

    /*** ACCESS LOGS PAGINATION PREVIOUS ***/
    jQuery(document).on('click', '#cm-hipaa-forms-logs-prev .cm-pagination-button', function() {
        var startDate = jQuery('#cm-hipaa-forms-logs-filter-start-date').val();
        var endDate = jQuery('#cm-submitted-form-filter-end-date').val();
        var limit = jQuery('#cm-hipaa-forms-logs-filter-limit').val();
        var page = jQuery('#cm-hipaa-forms-logs-filter-page').val();
        var resultsEle = jQuery('#cm-hipaa-forms-logs-results');
        var newPage = parseInt(page, 10)-1;

        cmGetLogs(startDate, endDate, limit, newPage, resultsEle);
    });

    /*** ACCESS LOGS PAGINATION NEXT ***/
    jQuery(document).on('click', '#cm-hipaa-forms-logs-next .cm-pagination-button', function() {
        var startDate = jQuery('#cm-hipaa-forms-logs-filter-start-date').val();
        var endDate = jQuery('#cm-submitted-form-filter-end-date').val();
        var limit = jQuery('#cm-hipaa-forms-logs-filter-limit').val();
        var page = jQuery('#cm-hipaa-forms-logs-filter-page').val();
        var resultsEle = jQuery('#cm-hipaa-forms-logs-results');
        var newPage = parseInt(page, 10)+1;

        cmGetLogs(startDate, endDate, limit, newPage, resultsEle);
    });

    /*** OPEN BAA FORM MODAL ***/
    jQuery(document).on('click', '.cm-sign-baa-button', function() {
        // CREATE THE MODAL
        jQuery('body').append('<div class="cm-baa-modal"><div class="cm-baa-modal-inner"><div class="cm-baa-modal-inner-top"><div class="cm-baa-modal-close"><i class="fa fa-times-circle" aria-hidden="true"></i></div></div><div class="cm-baa-modal-inner-body"><div class="cm-baa-modal-form"></div></div></div></div>');
        var nonce = hipaaScript.nonce;

        jQuery.ajax({
            method: 'POST',
            url: ajax.ajax_url,
            data: {
                'action': 'cm_hipaa_get_baa_form',
                'nonce': nonce
            },
            success: function (data) {
                var resultData = JSON.parse(data);

                jQuery('.cm-baa-modal-form').html(resultData.form);

                jQuery("#cm-baa-form-signature").jSignature();
            },
            error: function (errorThrown) {
                console.log(errorThrown);
                jQuery('.cm-baa-modal-form').html(errorThrown);
            }
        });

        // FADE IN MODAL
        jQuery('.cm-baa-modal').fadeIn();
    });

    /*** CLOSE MODAL ***/
    jQuery(document).on('click', '.cm-baa-modal-close', function() {
        var modal = jQuery(this).parent().parent().parent();

        // REMOVE MODAL WINDOW
        modal.fadeOut().promise().done(function() {
            modal.remove();
        });
    });

    /*** HIDE SIGN HERE IMAGE ***/
    jQuery(document).on('click', '#cm-baa-form-signature', function() {
        jQuery('.cm-baa-form-sign-here').hide();
    });

    /*** RESET SIGNATURE ***/
    jQuery(document).on('click', '#cm-baa-form-signature-reset', function() {
        jQuery('#cm-baa-form-signature').jSignature("reset");
        jQuery('.cm-baa-form-sign-here').show();
    });

    /*** SUBMIT BAA FORM ***/
    jQuery(document).on('click', '#cm-baa-form-submit', function() {
        var form = jQuery('.cm-baa-form').html();
        var agreeEle = jQuery('#cm-baa-form-agree');
        var noticeEle = jQuery('#cm-baa-form-notice');
        var signHere = jQuery('.cm-baa-form-sign-here');
        var signatureEle = jQuery('#cm-baa-form-signature');
        var signersName = jQuery('#cm-baa-form-signers-name').val();
        var nonce = hipaaScript.nonce;

        // RESET ERRORS
        agreeEle.css('border', '1px solid #b4b9be');
        signatureEle.css('border', '0');
        noticeEle.html('');

        // GET SIGNATURE SVG BASE64 DATA
        var datapair = signatureEle.jSignature("getData", "svgbase64");
        var signature = "data:" + datapair[0] + "," + datapair[1];

        // VALIDATE FORM
        if(agreeEle.attr('checked') !== 'checked') {
            agreeEle.css('border', '2px solid red');
            noticeEle.html('You must agree to the BAA Agreement!');
        } else if(signHere.is(':visible')) {
            signatureEle.css('border', '2px solid red');
            noticeEle.html('You must sign the BAA Agreement!');
        } else {
            // SUBMIT THE FORM
            jQuery.ajax({
                method: 'POST',
                url: ajax.ajax_url,
                data: {
                    'action': 'cm_hipaa_submit_baa_form',
                    'form': form,
                    'signature': signature,
                    'signers_name': signersName,
                    'nonce': nonce
                },
                success: function (data) {
                    var resultData = JSON.parse(data);

                    noticeEle.html(data);
                    jQuery('#cm-submitted-forms-results').html('Thank you for signing the BAA! You should now be authorized to use the HIPAA FORMS Service.<div><a href="' + data + '" target="_blank">View BAA</a></div>');
                    jQuery('#cm-hipaa-forms-signed-baa').html('<div><a href="' + data + '" target="_blank">View BAA</a></div>');
                },
                error: function (errorThrown) {
                    console.log(errorThrown);
                    noticeEle.html(errorThrown);
                }
            });
        }
    });

    /*** SUBMIT SUPPORT TICKET ***/
    jQuery('#cm-hipaa-forms-submit-ticket').click(function() {
        var priorityEle = jQuery('#cm-hipaa-forms-submit-ticket-priority');
        var subjectEle = jQuery('#cm-hipaa-forms-submit-ticket-subject');
        var messageEle = jQuery('#cm-hipaa-forms-submit-ticket-message');
        var noticeEle = jQuery('#cm-hipaa-forms-submit-ticket-notice');
        var priority = priorityEle.val();
        var subject = subjectEle.val();
        var message = messageEle.val();

        cmSubmitTicket(priorityEle, subjectEle, messageEle, noticeEle, priority, subject, message, '');
    });

    /*** TOGGLE SUPPORT TICKETS ***/
    jQuery(document).on('click', '.cm-support-ticket-toggle', function() {
        var ticketBody = jQuery(this).parent().parent().parent().find('.cm-support-ticket-body');

        // UPDATE ICON
        if(ticketBody.is(':visible')) {
            jQuery(this).html('<i class="far fa-caret-square-down"></i>');
        } else {
            jQuery(this).html('<i class="far fa-caret-square-up"></i>');
        }

        // TOGGLE TICKET
        ticketBody.slideToggle();
    });

    /*** REPLY TO SUPPORT TICKET ***/
    jQuery(document).on('click', '.cm-support-ticket-reply-submit', function() {
        var parentTicketId = jQuery(this).attr('data');
        var messageEle = jQuery(this).parent().parent().find('.cm-support-ticket-reply-input');
        var noticeEle = jQuery(this).parent().find('.cm-support-ticket-reply-notice');
        var message = messageEle.val();

        cmSubmitTicket('', '', messageEle, noticeEle, '', '', message, parentTicketId);
    });

    /*** CLOSE TICKETS ***/
    jQuery(document).on('click', '.cm-support-ticket-close', function() {
        var ticketId = jQuery(this).attr('data');
        var noticeEle = jQuery(this).parent().find('.cm-support-ticket-reply-notice');

        cmCloseTicket(ticketId, noticeEle);
    });
});

//Custom progress bar
function cmHipaaMoveProgress() {
    var elem = jQuery(".cm-hipaa-forms-progress-bar");
    var width = 10;
    var id = setInterval(frame, 25);
    function frame() {
        if (width >= 100) {
            width = 10;
        } else {
            width++;
            elem.css('width', width + '%');
            jQuery(".cm-hipaa-forms-progress-label").html( width + '%');
        }
    }
}

// GET BAA PDF URL
function cmGetBaaPdf() {
    var nonce = hipaaScript.nonce;

    jQuery.ajax({
        url: ajax.ajax_url,
        data: {
            'action': 'cm_hipaa_get_baa_pdf',
            'nonce': nonce
        },
        success: function (data) {
            var resultData = JSON.parse(data);

            if(resultData.success) {
                jQuery('#cm-hipaa-forms-signed-baa').html('<div><a href="' + resultData.content + '" target="_blank">View BAA</a></div>');
            } else {
                jQuery('#cm-hipaa-forms-signed-baa').html(resultData.error);
            }
        },
        error: function (errorThrown) {
            console.log(errorThrown);
            jQuery('#cm-hipaa-forms-signed-baa').html(errorThrown);
        }
    });
}

// GET FORMS
function cmGetForms(firstName, lastName, phone, email, limit, page, resultsEle) {
    if(!page) {
        page = 0;
    }

    if(!limit) {
        limit = 10;
    }

    if(!resultsEle) {
        resultsEle = jQuery('#cm-submitted-forms-results');
    }

    resultsEle.html('<div class="cm-hipaa-forms-progress-wrapper"><div class="cm-hipaa-forms-progress"><div class="cm-hipaa-forms-progress-bar"><!--    <div class="cm-hipaa-forms-progress-label">10%</div>--></div></div></div>');
    cmHipaaMoveProgress();
    var nonce = hipaaScript.nonce;

    jQuery.ajax({
        url: ajax.ajax_url,
        data: {
            'action': 'cm_hipaa_get_forms',
            'first_name': firstName,
            'last_name': lastName,
            'phone': phone,
            'email': email,
            'limit': limit,
            'page': page,
            'nonce': nonce
        },
        success:function(data) {
            var resultData = JSON.parse(data);

            jQuery('.cm-hipaa-forms-progress-wrapper').remove();
            var totalResults = resultData.total_results;

            // UPDATE TOTAL RESULTS VALUE
            jQuery('#cm-submitted-form-filter-total').val(totalResults);

            // ADD PAGINATION BUTTONS
            var resultsShown = +page * +limit;
            var totalResultsLeft = +totalResults - resultsShown;
            var totalPages = Math.ceil(+totalResults / +limit);
            var prevButton = '';
            var nextButton = '';
            var paginationButtons = '';

            // SET PREVIOUS BUTTON
            if(page > 0) {
                prevButton = '<div id="cm-hipaa-submitted-forms-prev" class="col_33""><div class="cm-pagination-button"><i class="fa fa-caret-left" aria-hidden="true"></i> Previous</div></div>';
            } else {
                prevButton = '<div id="cm-hipaa-submitted-forms-prev" class="col_33"></div>';
            }

            // SET NEXT BUTTON
            if(totalResultsLeft > limit) {
                nextButton = '<div id="cm-hipaa-submitted-forms-next" class="col_33"><div class="cm-pagination-button">Next <i class="fa fa-caret-right" aria-hidden="true"></i></div></div>';
            } else {
                nextButton = '<div id="cm-hipaa-submitted-forms-next" class="col_33"></div>';
            }

            // SET PAGE COUNT (PAGE X OF X)
            if(totalPages === parseInt(totalPages, 10) && totalPages > 0) {
                var resultsCount = '<div class="cm-hipaa-submitted-forms-count col_33">Page ' + (parseInt(page, 10) + 1) + ' of ' + totalPages + '</div>';
            }

            // SHOW PAGINATION BUTTONS IF NEEDED
            if(prevButton || nextButton) {
                paginationButtons = '<div class="cm-submitted-forms-pagination-wrapper"><div class="cm-submitted-forms-pagination grid_row">' + prevButton + resultsCount + nextButton + '</div></div>';
            }

            // UPDATE RESULTS
            resultsEle.html(resultData.content + ' ' + paginationButtons);

            // UPDATE PAGE
            jQuery('#cm-submitted-form-filter-page').val(page);
        },
        error: function(errorThrown){
            console.log(errorThrown);
        }
    });
}

// GET LOGS
function cmGetLogs(startDate, endDate, limit, page, resultsEle) {
    if(!page) {
        page = 0;
    }

    if(!limit) {
        limit = 10;
    }

    if(!resultsEle) {
        resultsEle = jQuery('#cm-hipaa-forms-logs-results');
    }

    resultsEle.html('<div class="cm-hipaa-forms-progress-wrapper"><div class="cm-hipaa-forms-progress"><div class="cm-hipaa-forms-progress-bar"><!--    <div class="cm-hipaa-forms-progress-label">10%</div>--></div></div></div>');
    cmHipaaMoveProgress();
    var nonce = hipaaScript.nonce;

    jQuery.ajax({
        url: ajax.ajax_url,
        data: {
            'action': 'cm_hipaa_get_logs',
            'first_name': startDate,
            'last_name': endDate,
            'limit': limit,
            'page': page,
            'nonce': nonce
        },
        success:function(data) {
            var resultData = JSON.parse(data);

            jQuery('.cm-hipaa-forms-progress-wrapper').remove();
            var totalResults = resultData.total_results;

            // UPDATE TOTAL RESULTS VALUE
            jQuery('#cm-hipaa-forms-logs-filter-total').val(totalResults);

            // ADD PAGINATION BUTTONS
            var resultsShown = +page * +limit;
            var totalResultsLeft = +totalResults - resultsShown;
            var totalPages = Math.ceil(+totalResults / +limit);
            var prevButton = '';
            var nextButton = '';
            var paginationButtons = '';

            // SET PREVIOUS BUTTON
            if(page > 0) {
                prevButton = '<div id="cm-hipaa-forms-logs-prev" class="col_33""><div class="cm-pagination-button"><i class="fa fa-caret-left" aria-hidden="true"></i> Previous</div></div>';
            } else {
                prevButton = '<div id="cm-hipaa-forms-logs-prev" class="col_33"></div>';
            }

            // SET NEXT BUTTON
            if(totalResultsLeft > limit) {
                nextButton = '<div id="cm-hipaa-forms-logs-next" class="col_33"><div class="cm-pagination-button">Next <i class="fa fa-caret-right" aria-hidden="true"></i></div></div>';
            } else {
                nextButton = '<div id="cm-hipaa-forms-logs-next" class="col_33"></div>';
            }

            // SET PAGE COUNT (PAGE X OF X)
            if(totalPages === parseInt(totalPages, 10) && totalPages > 0) {
                var resultsCount = '<div class="cm-hipaa-forms-logs-count col_33">Page ' + (parseInt(page, 10) + 1) + ' of ' + totalPages + '</div>';
            }

            // SHOW PAGINATION BUTTONS IF NEEDED
            if(prevButton || nextButton) {
                paginationButtons = '<div class="cm-hipaa-forms-logs-pagination-wrapper"><div class="cm-hipaa-forms-logs-pagination grid_row">' + prevButton + resultsCount + nextButton + '</div></div>';
            }

            // UPDATE RESULTS
            resultsEle.html(resultData.content + ' ' + paginationButtons);
console.log(page);
            // UPDATE PAGE
            jQuery('#cm-hipaa-forms-logs-filter-page').val(page);
        },
        error: function(errorThrown){
            console.log(errorThrown);
        }
    });
}

// SUBMIT TICKET
function cmSubmitTicket(priorityEle, subjectEle, messageEle, noticeEle, priority, subject, message, parentId) {
    // RESET VALIDATION
    if(priorityEle) {
        priorityEle.css('border', '1px solid #ddd');
    }
    if(subjectEle) {
        subjectEle.css('border', '1px solid #ddd');
    }
    if(messageEle) {
        messageEle.css('border', '1px solid #ddd');
    }
    if(noticeEle) {
        noticeEle.html('');
    }

    // VALIDATE
    if(priorityEle && !priority) {
        priorityEle.css('border', '1px solid red');
        noticeEle.html('Please select a priority level');
    } else if(subjectEle && !subject) {
        subjectEle.css('border', '1px solid red');
        noticeEle.html('Please enter a subject');
    } else if(messageEle && !message) {
        messageEle.css('border', '1px solid red');
        noticeEle.html('Please enter a message');
    } else {
        noticeEle.html('<img src="' + hipaaScript.pluginUrl + '/images/loading/loading10.gif" />');
        var nonce = hipaaScript.nonce;

        jQuery.ajax({
            method: 'POST',
            url: ajax.ajax_url,
            data: {
                'action': 'cm_hipaa_submit_support_ticket',
                'priority': priority,
                'subject': subject,
                'message': message,
                'parent_id': parentId,
                'nonce': nonce
            },
            success: function (data) {
                var resultData = JSON.parse(data);

                if(resultData.error) {
                    noiceEle.html(resultData.error);
                } else if(resultData.success) {
                    noticeEle.html(resultData.success);
                }

                // UPDATE SUPPORT TICKETS
                cmGetTickets('open', jQuery('#cm-hipaa-forms-open-tickets'));
                cmGetTickets('closed', jQuery('#cm-hipaa-forms-closed-tickets'));
            },
            error: function (errorThrown) {
                console.log(errorThrown);
                noticeEle.html(errorThrown);
            }
        });
    }
}

// GET TICKETS
function cmGetTickets(status, updateEle) {
    updateEle.html('<img src="' + hipaaScript.pluginUrl + '/images/loading/loading10.gif" />');
    var nonce = hipaaScript.nonce;

    jQuery.ajax({
        method: 'POST',
        url: ajax.ajax_url,
        data: {
            'action': 'cm_hipaa_get_support_tickets',
            'status': status,
            'nonce': nonce
        },
        success: function (data) {
            var ticketsData = JSON.parse(data);

            var tickets;
            if(ticketsData.success === 'success') {
                tickets = ticketsData.tickets;
            } else if(ticketsData.error) {
                tickets = ticketsData.error;
            } else {
                tickets = 'There was an error';
            }

            updateEle.html(tickets);
        },
        error: function (errorThrown) {
            console.log(errorThrown);
            updateEle.html(errorThrown);
        }
    });
}

function cmCloseTicket(ticketId, noticeEle) {
    var nonce = hipaaScript.nonce;

    jQuery.ajax({
        method: 'POST',
        url: ajax.ajax_url,
        data: {
            'action': 'cm_hipaa_close_support_ticket',
            'ticket_id': ticketId,
            'nonce': nonce
        },
        success: function (data) {
            if(data === 'success') {
                // UPDATE OPEN SUPPORT TICKETS
                cmGetTickets('open', jQuery('#cm-hipaa-forms-open-tickets'));

                // UPDATE CLOSED SUPPORT TICKETS
                cmGetTickets('closed', jQuery('#cm-hipaa-forms-closed-tickets'));
            } else {
                noticeEle.html(data);
            }
        },
        error: function (errorThrown) {
            console.log(errorThrown);
            noticeEle.html(errorThrown);
        }
    });
}