/**
 * Created by Spencer on 11/5/2016.
 *
 * Use curationScript.pluginUrl for the plugin url path (set at the top of curation.php)
 *
 */


jQuery(document).ready(function() {
    /*** CHECK IF FORMS ON THE PAGE ***/
    var forms = jQuery('form');
    forms.each(function() {
        var form = jQuery(this);
        var formMainId = form.attr('id');
        var formId = form.attr('data-form-id');
        if(!formId) {
            formId = formMainId;
        }
        var enabledForms = JSON.parse(cmHipaaScript.enabledForms);

        formIds = [];

        // LOOP JSON AND PUSH IDS TO ARRAY
        for(var i=0; i<enabledForms.length; i++){
            if(enabledForms[i]) {
                formIds.push(enabledForms[i]);
            }
        }

        if(jQuery.inArray(formId, formIds) !== -1) {
            // CHECK IF SSL ENABLED
            var protocol = document.location.protocol;
            var submitButton = jQuery(this).find('input[type="submit"]');

            // ENSURE SSL ENABLED IF FORM SELECTED AS HIPAA COMPLIANT (checks both Wordpress is_ssl AND document protocol for good measure)
            if(protocol === 'https:' && cmHipaaScript.ssl === '1') {
                // PREPEND THE ADDITIONAL FIELDS WRAPPER
                submitButton.before('<div class="cm-hipaa-forms-prepend"><div class="cm-hipaa-forms-privacy-statement-wrapper"></div><div class="grid_row"><div class="cm-hipaa-forms-prepend-left col_50"></div><div class="cm-hipaa-forms-prepend-right col_50"></div></div></div>').promise().done(function() {
                    // ADD THE PRIVACY STATEMENT INPUT
                    /*
                    jQuery('.cm-hipaa-forms-privacy-statement-wrapper').html('<div class="cm-hipaa-forms-privacy-statement"><input type="checkbox" id="cm-hipaa-forms-privacy-agree" /> I agree to the <span id="cm-hipaa-privacy-statement">HIPAA privacy statement</span></div>');
                    */

                    // ADD THE HIPAA COMPLIANT BADGE
                    jQuery('.cm-hipaa-forms-prepend-left').html('<div class="cm-hipaa-forms-privacy-statement"><input type="checkbox" id="cm-hipaa-forms-privacy-agree" /> I agree to the <span id="cm-hipaa-privacy-statement"><a href="https://www.hipaaforms.online/hipaa-privacy-statement/" target="_blank">HIPAA FORMS Service Privacy Statement</a></span></div><div class="cm-hipaa-forms-ssl-notice"><img src="' + cmHipaaScript.pluginUrl + '/images/hipaa-compliant-badge.png" alt="HIPAA COMPLIANT FORM" /></div>');

                    // ADD THE SIGNATURE FIELD
                    jQuery('.cm-hipaa-forms-prepend-right').html('<div class="cm-hipaa-form-signature-wrapper"><div class="cm-hipaa-form-signature-inner"><div id="cm-hipaa-form-signature"></div><div class="cm-hipaa-form-signature-label">To sign left click and drag mouse or use your finger or stylus if touch screen <span id="cm-hipaa-form-signature-reset" class="cm-button">RESET</span><span style="clear:both;"></span></div></div></div>').promise().done(function() {
                        jQuery("#cm-hipaa-form-signature").jSignature();
                    });

                    // SET NOTICE ELEMENT
                    submitButton.after('<div class="cm-hipaa-notice"></div>');
                });
            } else {
                submitButton.attr('disabled', 'disabled');

                submitButton.parent().append('<div class="cm-hipaa-forms-ssl-notice">This form is designated as a HIPAA compliant form however SSL (https) is not enabled so the form has been disabled.<br />Please ask the website administrators to fix this issue.</div>');
            }
        }
    });

    /*** SUBMIT HIPAA ENABLED FORM ***/
    jQuery(document).on('click', 'form input[type="submit"]', function(e){
        var submitButton = jQuery(this);
        var noticeEle = jQuery('.cm-hipaa-notice');
        var form = jQuery(this).parents('form:first');
        var formMainId = form.attr('id');
        var formId = form.attr('data-form-id');
        if(!formId) {
            formId = formMainId;
        }
        var enabledForms = JSON.parse(cmHipaaScript.enabledForms);
        formIds = [];

        // LOOP JSON AND PUSH IDS TO ARRAY
        for(var i=0; i<enabledForms.length; i++){
            if(enabledForms[i]) {
                formIds.push(enabledForms[i]);
            }
        }

        // IF FORM ID IS IN ENABLED FORMS PREVENT DEFAULT SUBMIT AND SEND TO CODE MONKEYS
        if(jQuery.inArray(formId, formIds) !== -1) {
            e.preventDefault(); //Prevent the normal submission action

            // LOOP INPUTS AND GET LABELS => VALUES
            var formFields = [];
            jQuery('#' + formMainId + ' :input').each(function() {
                var label = form.find('label[for="' + jQuery(this).attr('id') + '"]').html();
                var value = jQuery(this).val();
                var dataField = jQuery(this).attr('data-field');
                var fieldId = jQuery(this).attr('id');
                var fieldType = jQuery(this).attr('type');

                if(fieldType === 'checkbox') {
                    if(jQuery(this).attr('checked')) {
                        value = 'Yes';
                    } else {
                        value = 'No';
                    }
                }

                if(label) {
                    // IF LABEL EXISTS PUSH TO FIELDS ARRAY
                    formFields.push({
                        'label': label,
                        'value': value,
                        'data_field': dataField,
                        'field_id': fieldId,
                        'field_type': fieldType
                    });
                }
            });

            // GET SIGNATURE SVG BASE64 DATA
            var signatureEle = jQuery('#cm-hipaa-form-signature');
            var datapair = signatureEle.jSignature("getData", "svgbase64");
            var signature = "data:" + datapair[0] + "," + datapair[1];


            // SET PRIVACY AGREEMENT ELEMENT
            var privacyAgreementEle = jQuery('#cm-hipaa-forms-privacy-agree');

            // RESET ERRORS
            privacyAgreementEle.parent().css('border', '0');
            noticeEle.html('');

            var nonceEle = jQuery('#cm-hipaa-forms-nonce');
            var nonce = cmHipaaScript.nonce;

            // ENSURE THE HIPAA PRIVACY CHECKBOX IS CHECKED
            if(privacyAgreementEle.attr('checked') !== 'checked') {
                privacyAgreementEle.parent().css('border', '1px solid red');
                noticeEle.html('You must agree to the HIPAA Privacy Agreement');
            } else {
                // SUBMIT FORM
                jQuery.ajax({
                    method: 'POST',
                    url: ajax.ajax_url,
                    data: {
                        'action': 'cm_hipaa_submit_hipaa_form',
                        'formId': formId,
                        'formFields': formFields,
                        'signature': signature,
                        'nonce': nonce
                    },
                    success: function (data) {
                        if (data === 'success') {
                            // DISPLAY THE SUCCESS NOTICE
                            noticeEle.html('Thank you, your form has been encrypted to protect your privacy and submitted successfully!');

                            // RESET THE FORM
                            form[0].reset();
                            signatureEle.jSignature("reset");
                        } else {
                            // JUST A FAIL-SAFE JUST IN CASE WE DON'T ACTUALLY GET A SUCCESS MESSAGE
                            noticeEle.html(data);
                        }
                    },
                    error: function (errorThrown) {
                        console.log(errorThrown);
                        noticeEle.html(errorThrown);
                    }
                });
            }
        }
    });

    /*** RESET SIGNATURE ***/
    jQuery(document).on('click', '#cm-hipaa-form-signature-reset', function() {
        jQuery('#cm-hipaa-form-signature').jSignature("reset");
    });
});