<?php
/**
 * Created by Code Monkeys LLC
 * http://www.codemonkeysllc.com
 * User: Spencer
 * Date: 12/7/2017
 * Time: 5:56 PM
 */

// Add a custom user role
function cm_hipaa_add_roles_on_init() {
    // SET ROLE CAPABILITIES BASED ON PLUGIN SETTINGS
    $readPosts = 'false';
    $editPosts = 'false';
    $deletePosts = 'false';
    $installPlugins = 'false';
    $activatePlugins = 'false';
    $editPlugins = 'false';
    $updatePlugins = 'false';
    $deletePlugins = 'false';
    if(esc_attr(get_option('hipaa_role_read_posts_cap')) == 'on') {
        $readPosts = 'true';
    }
    if(esc_attr(get_option('hipaa_role_edit_posts_cap')) == 'on') {
        $editPosts = 'true';
    }
    if(esc_attr(get_option('hipaa_role_delete_posts_cap')) == 'on') {
        $deletePosts = 'true';
    }
    if(esc_attr(get_option('hipaa_role_install_plugins_cap')) == 'on') {
        $installPlugins = 'true';
    }
    if(esc_attr(get_option('hipaa_role_activate_plugins_cap')) == 'on') {
        $activatePlugins = 'true';
    }
    if(esc_attr(get_option('hipaa_role_edit_plugins_cap')) == 'on') {
        $editPlugins = 'true';
    }
    if(esc_attr(get_option('hipaa_role_update_plugins_cap')) == 'on') {
        $updatePlugins = 'true';
    }
    if(esc_attr(get_option('hipaa_role_delete_plugins_cap')) == 'on') {
        $deletePlugins = 'true';
    }

    // CREATE USER ROLE AND SET CAPABILITIES
    $role_created = add_role(
        'hipaa_forms', __( 'HIPAA Forms' ),
        array(
            'read' => $readPosts,
            'edit_posts' => $editPosts,
            'delete_posts' => $deletePosts,
            'install_plugins' => $installPlugins,
            'activate_plugins' => $activatePlugins,
            'edit_plugins' => $editPlugins,
            'update_plugins' => $updatePlugins,
            'delete_plugins' => $deletePlugins
        ));
}
add_action('init', 'cm_hipaa_add_roles_on_init');

/*** ADD HIPAA ACCESS CAPABILITY TO ADMIN AND HIPAA FORMS ROLES ***/
function cm_hipaa_add_role_cap() {
    $adminRole = get_role('administrator');
    $adminRole->add_cap('access_hipaa_forms', true);

    $hipaaRole = get_role('hipaa_forms');
    $hipaaRole->add_cap('access_hipaa_forms', true);
}
add_action('init', 'cm_hipaa_add_role_cap', 11);